" therion vi syntax file
"
" Language: therion (thconfig, .th, .th2)
" Maintainer: the position is available
"
" [1] To experiment: 
" save this file somewhere and source it when you edit a therion file,
"   :so therion.vim
"
" [2] If you are happy with it, you can install it.
" Install instructions (copied from vim syntax man):
"
" put this file among the vi syntax files, eg, in the directory
"     /usr/share/vim/vim??/syntax
" 
" add the following lines to your $(HOME)/.vimrc
"
" augroup filetype
"   au!
"   au! BufRead,BufNewFile *.th    set filetype=therion
"   au! BufRead,BufNewFile *.th2  set filetype=therion
"   au! BufRead,BufNewFile thconfig*    set filetype=therion
" augroup END
"
" [3] Want to have the syntax for all the users?
" Do not remember ...
"
" [4] Anything else ?
" Read the vi syntax man: a "source" of inspiration.
" 

syntax clear
syntax case match
setlocal iskeyword+=-

syntax match thComment /#.*/

syntax match thAt /@/

syntax region thString1 start=/"/ end=/"/
syntax region thString2 start=/\[/ end=/\]/

syntax keyword thConfig encoding system input select unselect revise grade
syntax keyword thConfig source endsource

syntax keyword thExportType atlas map model database continuation-list contained
syntax keyword thExport export nextgroup=thExportType skipwhite

syntax keyword thSketchAlgo line plaquette contained
syntax keyword thSketch sketch-warp nextgroup=thSketchAlgo skipwhite


syntax keyword thProjType plan extended elevation none contained
syntax keyword thProj -proj[ection] nextgroup=thProjType skipwhite

syntax keyword thExtendType normal reverse left right start ignore vertical hide contained
syntax keyword thExtend -extend extend nextgroup=thExtendType skipwhite

" =========================================
" generic options
syntax keyword thOption -id -author -copyright -title

syntax keyword thExportOpt -o[utput] -fmt -format

syntax keyword thFlagOpt surface duplicate not contained
syntax keyword thFlag flags nextgroup=thFlagOpt skipwhite

" =========================================
" layout

syntax keyword thLayoutCmd color colour copy debug language layers
syntax keyword thLayoutCmd map-comment map-header map-image
syntax keyword thLayoutCmd origin origin-label
syntax keyword thLayoutCmd rotate sketch[es] statistics
syntax keyword thLayoutCmd transparency opacity surface-opacity
syntax keyword thLayoutCmd legend legend-columns legend-width
syntax keyword thLayoutCmd grid grid-flip grid-origin grid-size grid-units
syntax keyword thLayoutCmd grid-coords
syntax keyword thLayoutCmd survey-level base-scale scale[-bar]
syntax keyword thLayoutCmd nav-factor nav-size 
syntax keyword thLayoutCmd overlap title-pages exclude-pages
syntax keyword thLayoutCmd own-pages page-grid page-numbers page-setup

syntax keyword thILayout -layout -layout-color -layout-colour -layout-debug
syntax keyword thILayout -layout-language -layout-layers 
syntax keyword thILayout -layout-map-comment -layout-map-header
syntax keyword thILayout -layout-map-image -layout-origin
syntax keyword thILayout -layout-origin-label -layout-rotate
syntax keyword thILayout -layout-sketch[es] -layout-statistics
syntax keyword thILayout -layout-transparency -layout-opacity
syntax keyword thILayout -layout-surface-opacity -layout-legend
syntax keyword thILayout -layout-legend-columns -layout-legend-width
syntax keyword thILayout -layout-grid -layout-grid-flip -layout-grid-origin
syntax keyword thILayout -layout-grid-size -layout-grid-units -layout-grid-coords
syntax keyword thILayout -layout-base-scale 
syntax keyword thILayout -layout-scale[-bar] -layout-survey-level
syntax keyword thILayout -layout-nav-factor -layout-nav-size
syntax keyword thILayout -layout-overlap -layout-title-pages
syntax keyword thILayout -layout-exclude-pages -layout-own-pages
syntax keyword thILayout -layout-page-grid -layout-page-numbers
syntax keyword thILayout -layout-page-setup

syntax keyword thDocOpt doc-author doc-keywords doc-title doc-subject

syntax keyword thLSymbolSet ASF BCRA NSS SKBB SM UIS
syntax keyword thLSymbolType all centerline sections contained
syntax keyword thLSymbolVal point line area group special nextgroup=thLSymbolType skipwhite contained
syntax keyword thLSymbol symbol-assign symbol-hide symbol-set symbol-show nextgroup=thLSymbolVal skipwhite
syntax keyword thILSymbol -layout-symbol-assign -layout-symbol-hide -layout-symbol-show -layout-symbol-set nextgroup=thLSymbolVal skipwhite

syntax keyword thLSurfaceVal top bottom off contained
syntax keyword thLSurface surface nextgroup=thLSurfaceVal skipwhite
syntax keyword thILSurface -layout-surface nextgroup=thLSurfaceVal skipwhite

syntax keyword thLNorthVal grid true contained
syntax keyword thLNorth north nextgroup=thLNorthVal skipwhite
syntax keyword thILNorth -layout-north nextgroup=thLNorthVal skipwhite

" syntax keyword thLayout layout endlayout 
syntax keyword thL endlayout
syntax region thLayout matchgroup=thL start=/layout/ end=/endlayout/ transparent

" syntax cluster thLayoutOpt contains=thLayoutCmd,thDocOpt

" ============================================

syntax keyword thQuantity backbearing backclino backcompass backgradient
syntax keyword thQuantity bearing ceiling clino compass counter 
syntax keyword thQuantity depth depthchange down easting
syntax keyword thQuantity floor fromcount fromdepth left length 
syntax keyword thQuantity northing right dx dy dz newline
syntax keyword thQuantity tape tocount todepth up ignore ignoreall

syntax keyword thUnits centimeter[s] deg degree[s] feet[s]
syntax keyword thUnits grad[s] inch[es] meter[s]
syntax keyword thUnits mil[s] min minute[s] percent[age]
syntax keyword thUnits yard[s]
" syntax match thUnits /\sm/
" syntax match thUnits /\scm/
syntax match thUnits /\sft/
syntax match thUnits /\syd/
" syntax match thUnits /\smils{0,1}/
" syntax match thUnits /\smin/

syntax keyword thDataVal normal diving cartesian cylpolar topofil from to station nextgroup=thDataVal skipwhite contained
syntax keyword thData data nextgroup=thDataVal skipwhite

" syntax cluster thDataOpt contains=thQuantity,thUnits,thData

" ----------------------------------
" commands with "end"

syntax keyword thCS cs
syntax keyword thCodeVal metapost tex-map tex-atlas contained
syntax keyword thCode code endcode nextgroup=thCodeVal skipwhite

syntax keyword thSurvey survey endsurvey
syntax keyword thSurveyCmd input equate join station-names
syntax keyword thSurveyOpt -declination -person-rename

syntax keyword thCenterline centerline centreline endcenterline endcentreline
syntax keyword thCenterlineCmd units instrument nosurvey sd 
syntax keyword thCenterlineCmd calibrate declination fix
syntax keyword thCenterlineCmd explo-date explo-team team
syntax keyword thCenterlineOpt -station-names

syntax keyword thSurface surface endsurface
syntax keyword thSurfaceCmd bitmap

syntax keyword thMap endmap
syntax match thMap /map\s/
syntax keyword thMapCmd preview above below break

syntax keyword thScrap scrap endscrap
syntax keyword thScrapOpt -scale -stations -walls

syntax keyword thGroup group endgroup

" syntax cluster thBlock contains=thCode,thSurvey,thCenterline,thSurface,thMap
" syntax cluster thBlock add=thScrap,thLayout,thGroup

" syntax cluster thBlockOpt contains=thCS,thSurveyCmd,thCenterlineCmd
" syntax cluster thBlockOpt add=thSurfaceCmd,thMapCmd

" ----------------------------------
" point  line  area

syntax keyword thPoint anchor fixed-ladder dimensions
syntax keyword thPoint air-draught altitude anastomosis aragonite
syntax keyword thPoint archeo-material arrow breakdown-choke bridge
syntax keyword thPoint camp cave-pearl ceiling-step chimney
syntax keyword thPoint continuation continuation-station
syntax keyword thPoint crystal curtain debris disk explored
syntax keyword thPoint entrance floor-step flowstone flowstone-choke
syntax keyword thPoint flute gradient gypsum gypsum-flower
syntax keyword thPoint height helictite karren moonmilk
syntax keyword thPoint low_end narrow_end no-equipment overhang
syntax keyword thPoint paleo-material passage-height pillar pit popcorn
syntax keyword thPoint raft raft-cone root rimstone-dam rimstone-pool rope
syntax keyword thPoint scallop sink soda-straw spring stalactite stalagmite
syntax keyword thPoint station station-name steps traverse
syntax keyword thPoint vegetable-debris vthreshold wall-calcite water-flow

" point subtypes
syntax keyword thPoint summer winter
syntax keyword thPoint permanent temporary painted fixed natural
syntax keyword thPoint intermittent paleo
syntax keyword thPoint invisible presumed unsurveyed underlying

syntax keyword thPointOpt -name -orient[ation] -text -value -align -from
syntax keyword thPointOpt -gradient -scrap -direction
syntax keyword thPointCmd point

syntax keyword thLine bedrock border ceiling-meander contour floor-meander
syntax keyword thLine map-connection section slope
syntax keyword thLine rock-border rock-edge wall

syntax keyword thLineOpt l-size mark r-size size smooth orientation walls
syntax keyword thLineOpt subtype 
syntax keyword thLineVal center end both head none
syntax keyword thLineVal bottom-left bottom-right
syntax keyword thLineVal top-left top-right 
" syntax keyword thLineVal right left
syntax keyword thLineCmd line endline

syntax keyword thScaleVal tiny small normal large huge contained
syntax keyword thScale -scale nextgroup=thScaleVal skipwhite

syntax keyword thOutlineOpt in out none  contained
syntax keyword thOutline -outline nextgroup=thOutlineOpt skipwhite

" syntax keyword thCloseOpt on off auto contained
syntax keyword thCloseOpt on off auto 
syntax keyword thClose -close -reverse -border nextgroup=thCloseOpt skipwhite

syntax keyword thLayerOpt top bottom

syntax keyword thColorVal altitude map scrap contained
syntax keyword thColorOpt map-fg map-bg preview-above preview-below nextgroup=thColorVal skipwhite

syntax match thDateVal /\d\{4\}\.\d\{1,2\}\.\d\{1,2\}/ contained
syntax keyword thDate date nextgroup=thDateVal skipwhite

syntax keyword thStatOpt topo-length explo-length

syntax keyword thArea blocks clay guano ice pebbles sand snow sump water
syntax keyword thAreaCmd area endarea 

syntax keyword thLabel label remark
syntax keyword thExtra extra
syntax match thExtra /\s+u/

syntax keyword thDrawOpt -clip -context -place -visibility -subtype

" syntax cluster thItem contains=thPoint,thLine,thArea,thLabel,thExtra
" syntax cluster thItemOpt contains=thPointOpt,thLineOpt,thDrawOpt
" syntax cluster thItemCmd contains=thPointCmd,thLineCmd,thAreaCmd

" -----------------------------------------------------------

syntax keyword thInferOpt equates plumbs contained
syntax keyword thInfer infer nextgroup=thInferOpt skipwhite

syntax keyword thHVOpt horizontal vertical contained
syntax keyword thHorVert adjust flip -flip nextgroup=thHVOpt skipwhite

syntax keyword thImportOpt -filter -cs -calibrate contained
syntax keyword thImport import nextgroup=thImportOpt skipwhite

syntax keyword thSurveysOpt use create ignore contained
syntax keyword thSurveys -surveys nextgroup=thSurveysOpt skipwhite

" TODO
" head
" dimension dimensions direction 
" surveys 
" traverse 

" highlight:
" Normal 
" DelimiterLabel 
" Comment         light-blue
" Todo            black on yellow
" Conditional     black on yellow
" Repeat          yellow
" Statement
" Character 
" Number          violet
" Float 
" Boolean 
" SpecialChar     red
" Special         red
" String          pink/violet
" Constant        pink
" PreProc         blue
" PreCondit       blue
" Error 
" Operator
" Function        light blue
" Type
" Structure       green
" StorageClass
" Include         ?
" Macro           blue
" Identifier      light blue

hi def link thComment Comment
hi def link thAt SpecialChar

hi def link thConfig Structure   
" red
hi def link thExportType SpecialChar
hi def link thProjType SpecialChar
" blue
hi def link thExport Macro

hi def link thDateVal Repeat
hi def link thDate Number

hi def link thSketchAlgo Include
hi def link thSketch StorageClass
hi def link thProj String
hi def link thExtendType Special
hi def link thExtend Constant
hi def link thOption PreProc
hi def link thL PreCondit
" hi def link thLayout PreCondit
" hi def link thLayoutOpt Error
" yellow
hi def link thLayoutCmd Operator
hi def link thILayout Operator

hi def link thLNorthVal Function
hi def link thLNorth Operator
hi def link thILNorth Operator

hi def link thLSurfaceVal Function
hi def link thLSurface Operator
hi def link thILSurface Operator

hi def link thLSymbolSet Special
hi def link thLSymbolType Number
hi def link thLSymbolVal Function
hi def link thLSymbol Operator
hi def link thILSymbol Operator

hi def link thDocOpt Operator

" hi def link thDataOpt Operator
hi def link thQuantity Operator
hi def link thUnits Special
hi def link thDataVal Function
hi def link thData Number

hi def link thExportOpt Operator
" hi def link thBlock Type
hi def link thCodeVal SpecialChar
hi def link thCode Type

hi def link thSurvey Type
hi def link thCenterline Type
hi def link thSurface Type
hi def link thMap Type
hi def link thScrap Type
hi def link thLayout Type
hi def link thGroup Type

" hi def link thBlockOpt Function
" Function = light blue
" Number   = pink
hi def link thCS Function
hi def link thSurveyCmd Special
hi def link thSurveyOpt Function
hi def link thCenterlineCmd Number
hi def link thCenterlineOpt Function
hi def link thSurfaceCmd Number
hi def link thMapCmd Function

hi def link thOutlineOpt Function
hi def link thOutline Number

hi def link thLayerOpt Function
hi def link thColorOpt Number
hi def link thColorVal Number

hi def link thStatOpt Number

hi def link thCloseOpt Function
hi def link thClose Number

hi def link thScrapOpt Number

" hi def link thItem Conditional
hi def link thPoint Conditional
hi def link thLine Conditional
hi def link thArea Conditional
hi def link thLabel Conditional
hi def link thExtra Conditional

" hi def link thItemOpt Number
hi def link thPointOpt Number
hi def link thLineOpt Number
hi def link thLineVal Function
hi def link thDrawOpt Number

hi def link thScale Number
hi def link thScaleVal Function

hi def link thInfer Statement
hi def link thInferOpt Character

hi def link thExtendOpt Float 

hi def link thFlagOpt Function
hi def link thFlag Number

hi def link thHVOpt Function
hi def link thHorVert Number

hi def link thSurveysOpt Function
hi def link thSurveys Number
hi def link thImportOpt Special
hi def link thImport Number

" hi def link thItemCmd SpecialChar 
hi def link thPointCmd Type
hi def link thLineCmd Type
hi def link thAreaCmd Type

hi def link thString1 Special
hi def link thString2 Special


